<?php

namespace App\Classes\Frame;

use Illuminate\Support\Facades\Log;

use App\Classes\Frame as AbstractFrame;
use App\Classes\Parser\Ansi as AnsiParser;

class Ansi extends AbstractFrame
{
	public static $frame_length = 22;
	public static $frame_width = 80;

	public static $header_length = 58;
	public static $pagenum_length = 11;
	public static $cost_length = 7;
	public static $cost_unit = 'u';

	public static $if_filler = '.';

	public function __construct(\App\Models\Frame $o,string $msg='')
	{
		parent::__construct($o);

		// If we have a message to display on the bottom line.
		if ($msg)
			$this->output .= ESC.'[24;0f'.$msg.HOME;
	}

	public function fields($startline=1)
	{
		$o = new AnsiParser($this->frame->content,$startline);
		$this->output .= (string)$o;

		$this->fields = $o->fields;
	}

	public function strlenv($text):int {
		return strlen($text ? preg_replace('/'.ESC.'\[[0-9;?]+[a-zA-Z]/','',$text) : $text);
	}
}